
#ifndef __HSCAL_BLACS_CBLACSGRIDINIT_HH
#define __HSCAL_BLACS_CBLACSGRIDINIT_HH

#include <stdio.h>

#include <stdlib.h>

#include "../../../include/scalapack.h"

int Cblacs_gridinit_nocomm(HSCALBLACSCONTEXT **ConTxt, char *order, int nprow, int npcol)
{
   int *tmpgrid, *iptr;
   int i, j;

/*
 * Grid can be row- or column-major natural ordering when blacs_gridinit is
 * called.  Define a tmpgrid to reflect this, and call blacs_gridmap to
 * set it up
 */
   iptr = tmpgrid = (int*) malloc( Mpval(nprow)*Mpval(npcol)*sizeof(*tmpgrid) );

   if (Mlowcase(F2C_CharTrans(order)) == 'c')
   {
      i = Mpval(npcol) * Mpval(nprow);
      for (j=0; j < i; j++) iptr[j] = j;
   }
   else
   {
      for (j=0; j < Mpval(npcol); j++)
      {
         for (i=0; i < Mpval(nprow); i++) iptr[i] = i * Mpval(npcol) + j;
         iptr += Mpval(nprow);
      }
   }

   Cblacs_gridmap_nocomm(ConTxt, tmpgrid, nprow, nprow, npcol);

   free(tmpgrid);

   return 0;
}

#endif
